Imports System.Windows.Forms
Imports Office = Microsoft.Office.Core
Imports Excel = Microsoft.Office.Interop.Excel
Imports MSForms = Microsoft.Vbe.Interop.Forms

' Office łB[NubÑX^[gAbv NXʂ܂BύXȂłB
<Assembly: System.ComponentModel.DescriptionAttribute("OfficeStartupClass, Version=1.0, Class=ExcelProject1.OfficeCodeBehind")>

Public Class OfficeCodeBehind 

    Friend WithEvents ThisWorkbook As Excel.Workbook
    Friend WithEvents ThisApplication As Excel.Application

    ' j[ o[{
    Private mainMenuBar As Office.CommandBar = Nothing
    ' j[ o[{̂ɕ\郁j[ځij[ڂ̃Xg\邽߂̃Rg[j
    Private mainMenuItem As Office.CommandBarControl = Nothing
    ' j[ Xgɕ\郁j[
    Friend WithEvents menuListItem As Office.CommandBarButton = Nothing

#Region "ꂽR[h"

    ' ̃RXgN^łB
    Public Sub New()
    End Sub

    ' KvȃvV[WłBύXȂłB
    Public Sub _Startup(ByVal application As Object, ByVal workbook As Object)
        ThisApplication = CType(application, Excel.Application)
        ThisWorkbook = CType(workbook, Excel.Workbook)

    
    End Sub

    ' KvȃvV[WłBύXȂłB
    Public Sub _Shutdown()
        ThisApplication = Nothing
        ThisWorkbook = Nothing
    End Sub

    ' ThisWorkbook ̃ANeBuȃ[NV[gɎw肳ꂽÕRg[Ԃ܂B
    Overloads Function FindControl(ByVal name As String) As Object
        Return FindControl(name, CType(ThisWorkbook.ActiveSheet, Excel.Worksheet))
    End Function

    ' w肳ꂽ[NV[gɎw肳ꂽÕRg[Ԃ܂B
    Overloads Function FindControl(ByVal name As String, ByVal sheet As Excel.Worksheet) As Object
        Dim theObject As Excel.OLEObject
        Try
            theObject = CType(sheet.OLEObjects(name), Excel.OLEObject)
            Return theObject.Object
        Catch Ex As Exception
            ' Rg[Ȃꍇ Nothing Ԃ܂B
        End Try
        Return Nothing
    End Function
#End Region

    ' [NubNJꂽƂɌĂяo܂B
    Private Sub ThisWorkbook_Open() Handles ThisWorkbook.Open
        Dim Sheet1 As Excel.Worksheet = ThisWorkbook.Sheets.Item(1)  ' @
        Sheet1.Cells(1, 1).Value2 = "Hello World!"  ' A

        ' ***** ȉ̃R[h͋Lɂ͌fڂĂ܂ ***** 

        ' C j[ o[ij[ o[̎w菈jB
        Me.mainMenuBar = InitMainMenuBar()
        If Me.mainMenuBar Is Nothing Then
            Return ' G[IG[̓\bhŕ\ς݁B
        End If

        ' C j[ɁuTravel toolsvƂڂ쐬B
        ' ...Ȃ݂ɕ̑OɁu&vƂ̕uAlt+ṽV[gJbgL[ɂȂB
        Me.mainMenuItem = CreateMenuBarItem(mainMenuBar, "&Travel tools")
        If Me.mainMenuItem Is Nothing Then
            Return ' G[IG[̓\bhŕ\ς݁B
        End If

        ' j[ځuTravel toolsvNbNꂽƂɕ\郁j[ Xg̍ڂ쐬B
        Me.menuListItem = CreateMenuListItem(mainMenuItem, "&Create Expense Report")
        If Me.menuListItem Is Nothing Then
            Return ' G[IG[̓\bhŕ\ς݁B
        End If

        ' GNZV[gɏݏ
        WriteStringToCell("B1", "Insider.NET")

        ' `[g쐬
        CreateChart()

        ' [U[ID\
        ShowUserID()
    End Sub

    ' [NubNOɌĂяo܂B̃\bh
    ' Ăяo邱ƂACancel Ɋ蓖ĂꂽĺA
    ' ق̃R[h⃆[U[ꍇɂ͖\܂B
    ' Cancel ́ACxgƂ False Ԃ܂BCxg vV[Wɂ
    ' True ɐݒ肳ꂽꍇAvV[WsꂽƂɃhLg͕܂B
    Private Sub ThisWorkbook_BeforeClose(ByRef Cancel As Boolean) Handles ThisWorkbook.BeforeClose
        Cancel = False
    End Sub

    ' C j[ o[̏
    Private Function InitMainMenuBar() As Office.CommandBar
        Dim cmdBar As Office.CommandBar = Nothing
        Try
            cmdBar = ThisApplication.CommandBars("Worksheet Menu Bar")
        Catch ex As Exception
            MessageBox.Show(ex.Message, ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return Nothing
        End Try
        Return cmdBar
    End Function 'InitMainMenuBar

    ' j[o[ɕ\鍀1쐬B
    Private Function CreateMenuBarItem(ByVal parentBar As Office.CommandBar, ByVal strCaption As String) As Office.CommandBarControl
        Dim cmdItem As Office.CommandBarControl = Nothing
        Try
            cmdItem = parentBar.Controls.Add(Office.MsoControlType.msoControlPopup, Temporary:=True)
            cmdItem.Caption = strCaption
            cmdItem.Visible = True
        Catch ex As Exception
            MessageBox.Show(ex.Message, ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return Nothing
        End Try
        Return cmdItem
    End Function 'CreateMenuBarItem


    ' j[ڂ̃Xgɕ\鍀1쐬B
    Private Function CreateMenuListItem(ByVal parentItem As Office.CommandBarPopup, ByVal strCaption As String) As Office.CommandBarButton
        Dim cmdItem As Office.CommandBarButton = Nothing
        Try
            cmdItem = parentItem.Controls.Add(Office.MsoControlType.msoControlButton, Temporary:=True)
            cmdItem.Caption = strCaption
            cmdItem.Visible = True
        Catch ex As Exception
            MessageBox.Show(ex.Message, ex.Source, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return Nothing
        End Try
        Return cmdItem
    End Function 'CreateMenuListItem


    ' j[ Xg̍ڂNbNꂽƂ̃Cxg nhB
    Private Sub MenuListItem_Click(ByVal ctrlItem As Office.CommandBarButton, ByRef cancelDefault As Boolean) Handles menuListItem.Click
        MessageBox.Show("j[ڃNbN")
    End Sub 'MenuListItem_Click


    ' Zւ̕ށB
    Public Sub WriteStringToCell(ByVal strCellID As String, ByVal strText As String)
        Dim sheet1 As Excel.Worksheet = ThisApplication.Sheets.Item("Sheet1")
        sheet1.Range(strCellID).Value = strText
    End Sub 'WriteStringToCell


    ' `[g쐬B
    Public Sub CreateChart()
        Dim thisWorksheet As Excel.Worksheet = ThisWorkbook.ActiveSheet
        Dim charts As Excel.ChartObjects = thisWorksheet.ChartObjects()

        ' Adds a chart at x = 100, y = 300, 500 points wide and 300 tall.
        Dim chartObj As Excel.ChartObject = charts.Add(100, 100, 500, 300)
        Dim chart As Excel.Chart = chartObj.Chart

        ' Gets the cells that define the bounds of the data to be charted.
        Dim chartRange As Excel.Range = thisWorksheet.Range("A5", "D8")
        chart.SetSourceData(chartRange)

        chart.ChartType = Excel.XlChartType.xlXYScatter
        Dim seriesCollection As Excel.SeriesCollection = chart.SeriesCollection()
        Dim series As Excel.Series = seriesCollection.Item(seriesCollection.Count)
    End Sub 'CreateChart


    ' ݂̃OI[U[ID\B
    Private Sub ShowUserID()
        Dim thisWorksheet As Excel.Worksheet = ThisWorkbook.ActiveSheet
        Dim userID As Excel.Range = thisWorksheet.Range("UserID")
        Dim user As System.Security.Principal.WindowsIdentity = System.Security.Principal.WindowsIdentity.GetCurrent()
        userID.Value2 = user.Name
    End Sub 'ShowUserID

End Class
